{------------------------------------------------------------------------------}
{
   Unit Name: sinform
   Purpose  : Nytt miten m3d:n luokkia kytetn
   Author   : Vesa Lappalainen
   Date     : 17.10.1999
   Changed  : 07.10.2001/vl
     - VCL/CLX-knns

   ToDo     :
}
{------------------------------------------------------------------------------}

unit sinform;

interface

uses
  Classes,
{$ifdef CLX}
  QGraphics, QControls, QForms, QDialogs, QStdCtrls,
{$else}
  Graphics, Controls, Forms, Dialogs, StdCtrls,
  Windows, Messages,
{$endif}
  m3d;

type
  TFormSin = class(TForm)
    ButtonKierra: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ButtonKierraClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    A:cTMatrix;
    dRect:cDRect;
    coord:cCoordinate;
    x1,x2,dx,deg:double;
    procedure scale;
  public
    { Public declarations }
  end;

var
  FormSin: TFormSin;

implementation
{$R *.dfm}

uses math;


//------------------------------------------------------------------------------
function p2(x:extended):extended;
begin
  Result := x*x - 2.0;
end;

function msin(x:extended):extended;
begin
  Result := sin(x);
end;

function mexp(x:extended):extended;
begin
  Result := exp(x);
end;

function mtan(x:extended):extended;
begin
  Result := tan(x);
end;

//------------------------------------------------------------------------------



procedure TFormSin.FormCreate(Sender: TObject);
begin
  A := cTMatrix.Create;
  dRect := cDRect.Create;
  coord := cCoordinate.Create;
  x1 := -PI; x2 := PI;  dx := (x2-x1)/200;
  deg := 20;
  dRect.scan(msin,x1,x2,dx);
  dRect.scan(p2,x1,x2,dx);
  scale;
end;

procedure TFormSin.scale;
begin
  A.scale(dRect,GetClientRect());
  coord.SetRect(dRect);
end;

procedure TFormSin.FormResize(Sender: TObject);
begin
  scale();
  Invalidate();
end;

procedure TFormSin.FormPaint(Sender: TObject);
var R : cRotMatrix; B : cTMatrix; dc : TCanvas;
begin
  dc := Canvas;
  R := cRotMatrix.Create(2,deg);
  B := cTMatrix.Create(A);
  B.Mul(R);
  coord.Draw(dc,A);
  Draw(dc,A,msin,x1,x2,dx,clRed);
  Draw(dc,B,p2,x1,x2,dx,clLime); // x^2 kuvaaja kierrettyn 20 ast.
  Draw(dc,A,mexp,x1,x2,dx,clBlue);
  Draw(dc,A,mtan,x1,x2,dx,clYellow);
  R.Free;
  B.Free;
end;

procedure TFormSin.ButtonKierraClick(Sender: TObject);
begin
  deg := deg + 10;
 {$ifdef CLX}
    InvalidateRect(ClientRect,true);
 {$else}
    Invalidate;
 {$endif}

end;

procedure TFormSin.FormDestroy(Sender: TObject);
begin
  A.Free;
  dRect.Free;
  coord.Free;
end;

end.
